Attribute VB_Name = "modMessageBox"
' vbzTipp   : System / vbzMsgBox
' Nummer    : 0002
' Stand     : 02.09.2009
' Quelle    : http://www.vb-zentrum.de

Option Explicit

' Implementierung:
' vbzMsgBox ist 100% abwrtskompatiebel zur VB-internen MsgBox
' Dadurch ist der Austausch in 1 bis 2 Minuten erledigt!

' Mglichkeit A:
' - fgen Sie dieses Modul in Ihr vorhandenes Projekt ein
' - Suchen und Ersetzen Sie MsgBox durch vbzMsgBox ("nur ganzes Wort suchen" aktivieren!)
'   Ihre Anwendung luft unverndert!
' - ergnzen Sie ggf. die neuen mglichen Parameter in Ihrem Programm
'
' Mglichkeit B:
' - fgen Sie dieses Modul in Ihr vorhandenes Projekt ein
' - Suchen und Ersetzen Sie in DIESEM Modul vbzMsgBox durch MsgBox
'   Die VB-eigene MsgBox wird dadurch ausgeblendet und durch diese ersetzt
'   Ihre Anwendung wird nicht verndert, bei Problemen entfernen Sie einfach
'   dieses Modul aus Ihrem Projekt
' - ergnzen Sie bei Bedarf die neuen zustzlichen Parameter in Ihrem Programm


' SubClassing:
Private Declare Function DefWindowProc Lib "user32" Alias "DefWindowProcA" _
        (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, _
        ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function SetWindowText Lib "user32" Alias "SetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

' Ereignisnummern fr unser SubClassing:
Private Const GWL_WNDPROC As Long = -4
Private Const WM_SETTEXT As Long = &HC&
Private Const WM_HELP As Long = &H53&
Private Const WM_CLOSE As Long = &H10&
Private Const WM_DESTROY As Long = &H2&
Private Const WM_CLICK As Long = &H111&

' vbzMsgBox
Private Declare Function MessageBox Lib "user32" Alias "MessageBoxA" (ByVal hwnd As Long, _
        ByVal lpText As String, ByVal lpCaption As String, ByVal msgType As VbMsgBoxStyle) As VbMsgBoxResult
' Bentigte API's fr das Manipulieren der MessageBox
Private Declare Function SendDlgItemMessage Lib "user32" Alias "SendDlgItemMessageA" (ByVal hDlg As Long, _
        ByVal nIDDlgItem As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As String) As Long
' Bentigte API's fr die Timer-Steuerung
Private Declare Function SetTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long, ByVal uElapse As Long, ByVal lpTimer As Long) As Long
Private Declare Function KillTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long
' Funktionen: Messagebox automatisch schlieen:
Private Declare Function GetActiveWindow Lib "user32" () As Long
Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
Private Const EV_CTEXTMSGBOX As Long = &H100&
Private Const EV_COUNTMSGBOX As Long = &H1000&
Private Const EV_LISTNMSGBOX As Long = &H2000&
Private Const EV_CLOSEMSGBOX As Long = &H5000&

Private formOrigin As Long      ' Adresse des originalen Fensterprozesses
Private boxTitle As String      ' Titeltext fr FindWindow in Zeitfuntion
Private actTime As Long         ' Sekundenzhler fr 'closeTime'
Private msgHelpFile As String   ' Hilfedatei-Name mit Pfad
Private msgHelpContext As Long  ' Kontextnummer fr Hilfe
Private hMessageBox As Long     ' Handle der MessageBox

' Variablen zur Speicherung der gewnschten Buttonbeschriftung
Private btnCaption1 As String
Private btnCaption2 As String
Private btnCaption3 As String

Public Function vbzMsgBox(ByVal Prompt As String, Optional ByVal Buttons As VbMsgBoxStyle = vbOKOnly, _
                Optional ByVal Title As String = vbNullString, Optional ByVal HelpFile As String = vbNullString, _
                Optional ByVal Context As Long = 0, Optional closeTime As Long = 0, _
                Optional ByVal btn1 As String, Optional ByVal btn2 As String, Optional ByVal btn3 As String) As VbMsgBoxResult
  Dim ret As Long
  Dim hwnd As Long
  Dim hlpFlag As Boolean
  Dim msgStyle As VbMsgBoxStyle
  Dim msgButtons As VbMsgBoxStyle
  
  ' Einen Titel sollte die Box schon haben:
  If Title = vbNullString Then Title = App.EXEName
  
  ' Fensterhandle, auf das sich die Messagebox bezieht:
  hwnd = GetActiveWindow
  
  ' Benutzertexte prfen und zhlen:
  If LenB(btn1) Then ret = 1
  If LenB(btn2) Then ret = ret + 1
  If LenB(btn3) Then ret = ret + 1
  
  ' Style und Buttons zerlegen:
  msgStyle = Buttons And &HFFFFFFF0   ' Style = alles auer Buttons!
  If ret Then                         ' Wenn Benutzertexte vorhanden
    msgButtons = vbOKOnly             ' Buttondetails lschen
  Else                                ' sonst
    msgButtons = Buttons And &HF      ' msgButtons rausfiltern
  End If
  
  ' ACHTUNG: in Kombination mit "vbYesNo" oder "vbAbortRetryIgnore"
  ' kann die Box NICHT automatisch geschlossen werden; der Bediener
  ' muss dann eine Auswahl treffen!
  If msgButtons = vbYesNo Then closeTime = 0
  If msgButtons = vbAbortRetryIgnore Then closeTime = 0

  ' Soll nach Zeit geschlossen werden?
  If (closeTime > 0) Then
    boxTitle = Title & " [" & CStr(closeTime) & "]" ' Titel mit Zeitanzeige
    actTime = closeTime
    SetTimer hwnd, EV_COUNTMSGBOX, 1000, AddressOf boxEvent ' im Sekundentakt
  Else
    boxTitle = Title
  End If
  
  ' Wenn Hilfekontext gewnsch:
  hlpFlag = (Context > 0)
  If hlpFlag Then
    ' Hilfedatei ermitteln:
    If HelpFile = vbNullString Then HelpFile = App.HelpFile
    If InStrB(1, HelpFile, "\") = 0 Then HelpFile = App.Path & "\" & HelpFile
    msgHelpFile = HelpFile                                  ' Hilfedatei
    msgHelpContext = Context                                ' Kontext der Hilfe
    msgButtons = msgButtons Or vbMsgBoxHelpButton           ' Hilfebutton anzeigen
    SetTimer hwnd, EV_LISTNMSGBOX, 100, AddressOf boxEvent  ' SubClassing auslsen
  End If
  ' Wenn keine Benutzertexte auf den msgButtons, dann Standard-MessageBox:
  If ret = 0 Then
    vbzMsgBox = MessageBox(hwnd, Prompt, boxTitle, msgStyle Or msgButtons)
  Else
    ' Beschriftung der msgButtons
    btnCaption1 = btn1
    btnCaption2 = btn2
    btnCaption3 = btn3
    ' msgButtons fr Benutzerfunktion "umformatieren":
    If hlpFlag Then msgButtons = vbMsgBoxHelpButton Else msgButtons = vbOKOnly
    ' API-Timer starten - Ereignis Buttonbeschriftung:
     SetTimer hwnd, EV_CTEXTMSGBOX, 30, AddressOf boxEvent
    ' API Message-Box mit gewnschter Buttonanzahl aufrufen
    If ret = 1 Then
      'Ein Button: "OK"
      ret = MessageBox(hwnd, Prompt, boxTitle, msgStyle Or vbOKOnly Or msgButtons)
      vbzMsgBox = vbOK
    ElseIf ret = 2 Then
      ' Zwei msgButtons: "OK", "Cancel"
      ret = MessageBox(hwnd, Prompt, boxTitle, msgStyle Or vbOKCancel Or msgButtons)
      ' Antwort auswerten und Rckgabewert festlegen
      Select Case ret
        Case vbOK
          vbzMsgBox = 1 ' erster Button gedrckt
        Case vbCancel
          vbzMsgBox = 2 ' zweiter Button gedrckt
      End Select
    Else
      ' Drei msgButtons: "Yes", "No", "Cancel"
      ret = MessageBox(hwnd, Prompt, boxTitle, msgStyle Or vbYesNoCancel Or msgButtons)
      ' Antwort auswerten und Rckgabewert festlegen
      Select Case ret
        Case vbYes
          vbzMsgBox = 1 ' erster Button gedrckt
        Case vbNo
          vbzMsgBox = 2 ' zweiter Button gedrckt
        Case Else
          vbzMsgBox = 3 ' dritter Button gedrckt
      End Select
    End If
  End If
End Function

Private Sub boxEvent(ByVal hwnd As Long, ByVal uMsg As Long, ByVal idEvent As Long, ByVal dwTime As Long)
  KillTimer hwnd, idEvent                       ' Timer erst mal lschen
  hMessageBox = FindWindow("#32770", boxTitle)  ' Handle der Messagebox finden
  If hMessageBox Then
    Select Case idEvent
      Case EV_LISTNMSGBOX       ' SubClassing starten
        startListen hMessageBox
        
      Case EV_COUNTMSGBOX       ' Zeitereignis (Counter) ist eingetreten
        actTime = actTime - 1   ' 1 Sekunde runterzhlen
        boxTitle = Left(boxTitle, InStrRev(boxTitle, " [")) & "[" & CStr(actTime) & "]"
        SetWindowText hMessageBox, boxTitle
        If actTime < 2 Then idEvent = EV_CLOSEMSGBOX
        SetTimer hMessageBox, idEvent, 1000, AddressOf boxEvent
        
      Case EV_CLOSEMSGBOX       ' Die Box soll geschlossen werden
        SendMessage hMessageBox, WM_CLOSE, 0&, 0&
        
      Case EV_CTEXTMSGBOX       ' Benutzertexte fr Button
        If LenB(btnCaption2) = 0 Then     ' nur ein Button
          SendDlgItemMessage hMessageBox, vbCancel, WM_SETTEXT, 0, btnCaption1
        ElseIf LenB(btnCaption3) = 0 Then                            ' 2 bis 3 Buttons
          SendDlgItemMessage hMessageBox, vbOK, WM_SETTEXT, 0, btnCaption1
          SendDlgItemMessage hMessageBox, vbCancel, WM_SETTEXT, 0, btnCaption2
        Else
          SendDlgItemMessage hMessageBox, vbYes, WM_SETTEXT, 0, btnCaption1
          SendDlgItemMessage hMessageBox, vbNo, WM_SETTEXT, 0, btnCaption2
          SendDlgItemMessage hMessageBox, vbCancel, WM_SETTEXT, 0, btnCaption3
        End If
        
    End Select
  End If
End Sub

' SubClassing
' Erlaubt uns Ereignisse der Messagebox mitzuhren
' siehe Funktion: boxListen
Private Sub startListen(ByVal hwnd As Long)
  If formOrigin = 0 Then
    formOrigin = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf boxListen)
  End If
End Sub

' Mithren wieder abschalten
Private Sub stopListen(ByVal hwnd As Long)
   If formOrigin Then
     SetWindowLong hwnd, GWL_WNDPROC, formOrigin
     formOrigin = 0
   End If
End Sub

' Die 'Mithr'-Funktion ;-)
Private Function boxListen(ByVal hwnd As Long, ByVal uMsg As Long, _
                            ByVal wParam As Long, ByVal lParam As Long) As Long
  Dim blHelp As Boolean
  
  ' 1.) Standard Prozeduren zuerst abwickeln:
  boxListen = CallWindowProc(formOrigin, hwnd, uMsg, wParam, lParam)
  
  ' 2.) dann unsere Erweiterungen:
  Select Case uMsg
    Case WM_HELP              ' [F1] auf MessageBox wurde bettigt
      blHelp = True
    Case WM_CLICK             ' Mausklick auf Messagebox
      blHelp = wParam = 9     ' 9 = Hilfebutton!
    Case WM_CLOSE, WM_DESTROY ' Beim Schlieen-Ereignis SubClassing abschalten!
      stopListen hwnd
  End Select
  If blHelp Then
    ' Als Beispiel eine MessageBox! Hier muss natrlich der
    ' Aufruf der Hilfedatei mit Kontextnummer erfolgen:
    MessageBox 0, "Hilfe zur MessageBox wurde bettigt!" & vbCr & vbCr & _
                  "Datei: " & msgHelpFile & vbCr & _
                  "bergebene KontextNr: " & msgHelpContext, "Onlinehilfe", vbInformation Or vbSystemModal
  End If
End Function

